%% Demo

clear all;

% Initialization

opt.doPlot = 1;   % Plot or not

K      = 3;         % No. endmembers
M      = 5;         % Dimensions
N      = 2000;      % No. samples
sigma2 = 1e-5;      % Noise variance
mix    = [0.7 0.9 1];   % Mixing profile

% Generate synthetic dataset
figure(1);
[X W H opt] = genSynthSimplexData(K, M, N, sigma2, mix, opt);


%% Unmix all datapoint at once

opt.maxIt      = 5000;
opt.maxItLocal = 100;
opt.tol        = 1e-8;
opt.alpha      = 1e-1;
opt.stepH      = 1e-3;
opt.stepW      = 1e-3;
opt.reg        = 'dist';
opt.H.init     = [];        % [] means random init.
opt.W.init     = [];        % [] means random init.
opt.W.lock     = [];        % [] means update W also
opt.doPlot     = 100;

figure(10);
[W H] = NMF_Vol(X, K, opt);

E_res = sum(sum((X-W*H).^2)) / (size(X,1)*size(X,2));
E_s   = sum(sum((X).^2))     / (size(X,1)*size(X,2));
E_wh  = sum(sum((W*H).^2))   / (size(X,1)*size(X,2));
E_res/E_s*100

